// Purpose: draw the performance profile for each solver
// The resultats are given under a matrix format.
// Each column contains information about a solver
// Each line contains information about a problem 

p_s1=read(getenv('HOME')+'/CONTRIB/matrix.dat',-1,3);
//p_s1(find(p_s1==10000))=5500;
[np,ns] = size(p_s1);
pp=[];
p_s=[];
log2pp=[];
log2p_s=[];
M=100;

for i=1:np
 for j=1:ns
  p_s(i,j) = p_s1(i,j)/min(p_s1(i,:));
  log2p_s(i,j) = log2(p_s(i,j));
 end
end

deff('[pp]=pprofile(s,t)','pp=max(size(find(s<=t)))/np')
xbasc();
t=linspace(1,M,5*M);
for j=1:ns
 for i=1:5*M
  pp(i,j)=pprofile(p_s(:,j),t(i));
 end
plot2d2(t,pp(:,j),j);
end
legends(['quasi-Newton','gradient conjugue','L-BFGS-b'],[1,2,3]);
xtitle('Performance profile sur tous les problemes sans contraintes de CUTEr');


M=12;
logt = linspace(0,M,10*M);
xset('window',1);
for j=1:ns
 for i=1:10*M
  log2pp(i,j) = pprofile(log2p_s(:,j),logt(i)');
 end
 if (j==1) then
   plot2d2(logt,log2pp(:,j),5);
 else
   plot2d2(logt,log2pp(:,j),j);
 end
end
legends(['quasi-Newton','gradient conjugue','L-BFGS-b'],[5,2,3]);
xtitle('Performance profile sur tous les problemes sans contraintes de CUTEr');


//linspace(x,y,z) cree un vecteur [x,...,y] de z elements

