      subroutine siftools
c     Author: S. Steer, Copyright INRIA
c     gateway for sif tools
c     ['usetup','udimen','unames1','uvarty','ufn','ugr','uofg','udh',..
C          'ugrdh','ureprt','uprod','udimsh','ush','ubandh',..
C          'csetup','cdimen','cnames1','cvarty','cfn','cgr','cofg','cdh',..
C           'cgrdh','creprt','cprod','ccfg','ccfsg1','ccifg', 'ccifsg','cidh','cish']
      include 'stack.h'
c
      if(fin.eq.1) then
c     .  [X,BL,BU]=usetup(file_path)
         call intusetup('usetup')
      elseif (fin.eq.2) then
c     .  N=udimen()
         call intudimen('udimen')
      elseif (fin.eq.3) then
c     .  [PNAME,XNAMES]=unames()
         call intunames('unames')
      elseif (fin.eq.4) then
c     .  ivarty=uvarty()
         call intuvarty('uvarty')
      elseif (fin.eq.5) then
c     .  [F]=ufn(X)
         call intufn('ufn')
      elseif (fin.eq.6) then
c     .  [G]=ugr(X)
         call intugr('ugr')
      elseif (fin.eq.7) then
c     .  [F,G]=uofg(X)
         call intuofg('uofg')
      elseif (fin.eq.8) then
c     .  H=udh(X)
         call intudh('udh')
      elseif (fin.eq.9) then
c     .  [G,H]=ugrdh(X)
         call intugrdh('ugrdh')
      elseif (fin.eq.10) then
c     .  [time,calls]=ureprt();    
         call intureprt('ureprt')
      elseif (fin.eq.11) then
c     .  q=uprod(x,p,goth)
         call intuprod('uprod')
      elseif (fin.eq.12) then
c     .  nnzh=udimsh()
         call intudimsh('udimsh')
      elseif (fin.eq.13) then
c     .  [SH,ICNH,IRNH]=ush1()
         call intush('ush')
      elseif (fin.eq.14) then
c     .  bandh=ubandh(x,nsemib,goth)
         call intubandh('ubandh')
      elseif (fin.eq.15) then
c     .  [x,bl,bu,v,cl,cu,equatn,linear]=csetup(file_path,options)
         call intcsetup('csetup')
      elseif (fin.eq.16) then
c     .  [N,M]=cdimen()
         call intcdimen('cdimen')
      elseif (fin.eq.17) then
c     .  [PNAME,XNAMES,GNAMES]=cnames()
         call intcnames('cnames')
      elseif (fin.eq.18) then
c     .  ivarty=cvarty()
         call intcvarty('cvarty')
      elseif (fin.eq.19) then
c     .  [F,C]=cfn(X)
         call intcfn('cfn')
      elseif (fin.eq.20) then
c     .  [G,Cjac]=cgr(X,V,options)
         call intcgr('cgr')
      elseif (fin.eq.21) then
c     .  [F,G]=cofg(X)
         call intuofg('cofg')
      elseif (fin.eq.22) then
c     .  H=cdh(X,V)
         call intcdh('cdh')
      elseif (fin.eq.23) then
c     .  [G,CJAC,H]=cgrdh(X,V,options)
         call intcgrdh('cgrdh')
      elseif (fin.eq.24) then
c     .  [time,calls]=creprt();    
         call intcreprt('creprt')
      elseif (fin.eq.25) then
c     .  q=cprod(x,v,p,goth)
         call intcprod('cprod')
      elseif (fin.eq.26) then
c     .  [c,cjac]=ccfg(x,jtrans)
         call intccfg('ccfg')
      elseif (fin.eq.27) then
c     .  [c,ij,v]=ccfsg1(x)
         call intccfsg1('ccfsg1')
      elseif (fin.eq.28) then
c     .  [ci,gci]=ccifg(x,i)
         call intccifg('ccifg')
      elseif (fin.eq.29) then
c     .  [ci,gci]=ccifsg(x,i)
         call intccifsg('ccifsg')
      elseif (fin.eq.30) then
c     .   Hi=cidh(x,i)
         call intcidh('cidh')
      elseif (fin.eq.31) then
c     .   Hi=cish(x,i)
         call intcish('cish')

      endif
      call putlhsvar
      return
      end


      subroutine intusetup(fname)
c     Author: S. Steer, Copyright INRIA
c     [X,BL,BU]=usetup(file_path)
      include 'stack.h'

      logical getrhsvar,createvar
      logical checklhs,checkrhs
      integer getcuterr

      external getrhsvar,createvar, checklhs,checkrhs
      external getcuterr
      character fname*(*)
      character*128 path
      integer prbdat,mode(2)
      COMMON / toolssize / NVAR,M
      save / toolssize /
c
      if(.not.checklhs(fname,1,3)) return
      if(.not.checkrhs(fname,1,1)) return
      if(.not.getrhsvar(1,'c', Mp, Np, lP)) return
      mode(1)=1
      mode(2)=0
      path=cstk(lP:lP+mp*np)
      prbdat=0
      call clunit(prbdat,path,mode)
      if(err.gt.0) then
         call error(err)
         return
      endif
c     read the problem dimension to be able to allocate
      READ(prbdat,'(i8)') NVAR
      rewind(prbdat)
      if(.not.createvar(2,'d', NVAR, 1, lX)) goto 10
      if(.not.createvar(3,'d', NVAR, 1, lBL)) goto 10 
      if(.not.createvar(4,'d', NVAR, 1, lBU)) goto 10 
      CALL USETUP(prbdat, wte, NVAR, stk(lX), stk(lBL), stk(lBU), NVAR)
      ierr=getcuterr()
      if (ierr.ne.0) then
         if (ierr.eq.-1) then
            buf='Overdimensionned problem'
         elseif(ierr.eq.1) then
            buf='the problem includes general constraints'
         elseif(ierr.eq.2) then
            buf='the problem uses no variables'
         elseif(ierr.eq.3) then
            buf='the problem is vacuous'
         endif
            call error(998)
         return
      endif
      lhsvar(1)=2
      lhsvar(2)=3
      lhsvar(3)=4
 10   call clunit(-prbdat,path,mode)
      return
      end

      subroutine intudimen(fname)
c     Author: S. Steer, Copyright INRIA
c     N=dimen()
      include 'stack.h'

      logical getrhsvar,createvar
      logical checklhs,checkrhs

      external getrhsvar,createvar, checklhs,checkrhs
      character fname*(*)
      COMMON / toolssize / NVAR,M
      save / toolssize /
c
      rhs=max(0,rhs)
      if(.not.checklhs(fname,1,1)) return
      if(.not.checkrhs(fname,0,0)) return
      if(.not.createvar(1,'d', 1, 1, lN)) return
      stk(lN)=NVAR
      lhsvar(1)=1
      return
      end

      subroutine intunames(fname)
c     Author: S. Steer, Copyright INRIA
c     [PNAME,XNAMES]=unames()
      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs,cresmat4
      external getrhsvar,createvar, checklhs,checkrhs,cresmat4
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      rhs=max(0,rhs)
      if(.not.checkrhs(fname,0,0)) return
      if(.not.checklhs(fname,1,2)) return

      if(.not.createvar(1,'c', 10, 1, lPNAME)) return
      if(.not.createvar(2,'c', NVAR, 10, lXNAMES)) return
      CALL UNAMES( NVAR, cstk(lPNAME:), cstk(lXNAMES:))
      lhsvar(1)=1
      lhsvar(2)=2
      return
      end

      subroutine intufn(fname)
c     Author: S. Steer, Copyright INRIA
c     [F]=ufn(X)
      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      if(.not.checkrhs(fname,1,1)) return
      if(.not.checklhs(fname,1,1)) return
      if(.not.getrhsvar(1,'d', Mx, Nx, lX)) return
      if (mx*nx.ne.NVAR) then
         buf='X does not match current problem dimension'
         call error(999)
         return
      endif
      if(.not.createvar(2,'d', 1, 1, lF)) return
      CALL UFN( NVAR, stk(lX), stk(lF) )
      lhsvar(1)=2
      return
      end

      subroutine intugr(fname)
c     Author: S. Steer, Copyright INRIA
c     [G]=ugr(X)
      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      if(.not.checkrhs(fname,1,1)) return
      if(.not.checklhs(fname,1,1)) return
      if(.not.getrhsvar(1,'d', Mx, Nx, lX)) return
      if (mx*nx.ne.NVAR) then
         buf='X does not match current problem dimension'
         call error(999)
         return
      endif
      if(.not.createvar(2,'d', NVAR, 1, lG)) return
      CALL UGR( NVAR, stk(lX), stk(lG) )
      lhsvar(1)=2
      return
      end

      subroutine intuofg(fname)
c     Author: S. Steer, Copyright INRIA
c     [F,G]=uofg(X)
      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      if(.not.checkrhs(fname,1,1)) return
      if(.not.checklhs(fname,1,2)) return
      if(.not.getrhsvar(1,'d', Mx, Nx, lX)) return
      if (mx*nx.ne.NVAR) then
         buf='X does not match current problem dimension'
         call error(999)
         return
      endif
      if (lhs.eq.1) then
         if(.not.createvar(2,'d', 1, 1, lF)) return
         CALL UOFG( NVAR, stk(lX), stk(lF), stk(lG),.FALSE.)
         lhsvar(1)=2
      else
         if(.not.createvar(2,'d', 1, 1, lF)) return
         if(.not.createvar(3,'d', NVAR , 1, lG)) return
         CALL UOFG( NVAR, stk(lX), stk(lF), stk(lG),.TRUE.)
         lhsvar(1)=2
         lhsvar(2)=3
      endif
      return
      end

      subroutine intudh(fname)
c     Author: S. Steer, Copyright INRIA
c     H=udh(X)
      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      if(.not.checkrhs(fname,1,1)) return
      if(.not.checklhs(fname,1,1)) return
      if(.not.getrhsvar(1,'d', Mx, Nx, lX)) return
      if (mx*nx.ne.NVAR) then
         buf='X does not match current problem dimension'
         call error(999)
         return
      endif
      if(.not.createvar(2,'d', NVAR, NVAR, lDH)) return
      CALL UDH( NVAR, stk(lX),NVAR, stk(lDH))
      lhsvar(1)=2
      return
      end

      subroutine intugrdh(fname)
c     Author: S. Steer, Copyright INRIA
c     [G,H]=ugrdh(X)
      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      if(.not.checkrhs(fname,1,1)) return
      if(.not.checklhs(fname,2,2)) return
      if(.not.getrhsvar(1,'d', Mx, Nx, lX)) return
      if (mx*nx.ne.NVAR) then
         buf='X does not match current problem dimension'
         call error(999)
         return
      endif
      if(.not.createvar(2,'d', NVAR, 1, lG)) return
      if(.not.createvar(3,'d', NVAR, NVAR, lDH)) return
      CALL UGRDH( NVAR, stk(lX), stk(lG), NVAR, stk(lDH))
      lhsvar(1)=2
      lhsvar(2)=3
      return
      end

      subroutine intureprt(fname)
c     Author: S. Steer, Copyright INRIA
c     [time,calls]=ureprt();    
      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
c
      REAL               CALLS( 4 )
      REAL               TIME( 2 )
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      rhs=max(0,rhs)
      if(.not.checkrhs(fname,0,0)) return
      if(.not.checklhs(fname,1,2)) return
      if(.not.createvar(1,'d', 1, 2, lT)) return
      if(.not.createvar(2,'d', 1, 4, lC)) return
      call UREPRT(CALLS, TIME)
      do 10 i=1,2
         stk(lT+i-1)=TIME(i)
 10   continue
      do 11 i=1,4
         stk(lC+i-1)=CALLS(i)
 11   continue

      lhsvar(1)=1
      lhsvar(2)=2
      return
      end


      subroutine intuprod(fname)
c     Author: S. Steer, Copyright INRIA
c     q=uprod(x,p [,goth])

      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
c
      LOGICAL           GOTH
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      rhs=max(0,rhs)
      if(.not.checkrhs(fname,2,3)) return
      if(.not.checklhs(fname,1,1)) return

      if(.not.getrhsvar(1,'d', Mx, Nx, lX)) return
      if (mx*nx.ne.NVAR) then
         buf='X does not match current problem dimension'
         call error(999)
         return
      endif
      if(.not.getrhsvar(2,'d', Mp, Np, lP)) return
      if (mp*np.ne.NVAR) then
         buf='Incorrect dimension for P'
         call error(999)
         return
      endif
      GOTH=.false.
      if (rhs.eq.3) then
         if(.not.getrhsvar(3,'b', Mg, Ng, lG)) return
         if(istk(lG).ne.0) GOTH=.true.
      endif

      if(.not.createvar(rhs+1,'d', NVAR, 1, lQ)) return
      call UPROD( NVAR, GOTH, stk(lX), stk(lP), stk(lQ) )
      lhsvar(1)=rhs+1
      return
      end


      subroutine intuvarty(fname)
c     Author: S. Steer, Copyright INRIA
c     ivarty=uvarty()

      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      rhs=max(0,rhs)
      if(.not.checkrhs(fname,0,0)) return
      if(.not.checklhs(fname,1,1)) return

      if(.not.createvar(1,'i', NVAR, 1, lI)) return
      call UVARTY(NVAR, istk(lI) )
      lhsvar(1)=1
      return
      end

      subroutine intudimsh(fname)
c     Author: S. Steer, Copyright INRIA
c     NNZH=udimsh()

      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      rhs=max(0,rhs)
      if(.not.checkrhs(fname,0,0)) return
      if(.not.checklhs(fname,1,1)) return

      if(.not.createvar(1,'i', 1, 1, lI)) return
      call UDIMSH( istk(lI) )
      lhsvar(1)=1
      return
      end

      subroutine intush(fname)
c     Author: S. Steer, Copyright INRIA
c     [SH,ICNH,IRNH]=ush1(X)

      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
      integer nnz
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      rhs=max(0,rhs)
      if(.not.checkrhs(fname,1,1)) return
      if(.not.checklhs(fname,3,3)) return

      if(.not.getrhsvar(1,'d', Mx, Nx, lX)) return
      if (mx*nx.ne.NVAR) then
         buf='X does not match current problem dimension'
         call error(999)
         return
      endif
      call UDIMSH(nnz)
      if(.not.createvar(2,'d', nnz, 1, lV)) return
      if(.not.createvar(3,'i', nnz, 1, lIR)) return
      if(.not.createvar(4,'i', nnz, 1, lIC)) return
      call USH(NVAR, stk(lX),NNZ,NNZ,stk(lV), istk(lIR), istk(lIC))
      lhsvar(1)=2
      lhsvar(1)=3
      lhsvar(1)=4

      return
      end

      subroutine intubandh(fname)
c     Author: S. Steer, Copyright INRIA
c     bandh=ubandh(x,nsemib,goth)

      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
      logical GOTH
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      if(.not.checkrhs(fname,2,3)) return
      if(.not.checklhs(fname,1,1)) return

      if(.not.getrhsvar(1,'d', Mx, Nx, lX)) return
      if (mx*nx.ne.NVAR) then
          buf='X does not match current problem dimension'
         call error(999)
         return
      endif
      if(.not.getrhsvar(2,'d', Mn, Nn, lN)) return
      NSEMIB=stk(lN)

      GOTH=.false.
      if (rhs.eq.3) then
         if(.not.getrhsvar(3,'b', Mg, Ng, lG)) return
         if(istk(lG).ne.0) GOTH=.true.
      endif
      if(.not.createvar(rhs+1,'d',NSEMIB+1,NVAR, lB)) return
      CALL UBANDH( NVAR, GOTH, stk(lX), NSEMIB, stk(lB), NSEMIB )
      lhsvar(1)=rhs+1
      return
      end

      subroutine intcsetup(fname)
c     [x,bl,bu,v,cl,cu,equatn,linear]=csetup(file_path,options)
c     Author: S. Steer, Copyright INRIA
      include 'stack.h'

      logical getrhsvar,createvar
      logical checklhs,checkrhs
      integer getcuterr
      logical  efirst,lfirst,nvfrst
      external getrhsvar,createvar, checklhs,checkrhs
      external getcuterr
      character fname*(*)
      character*128 path
      integer prbdat,mode(2)
      COMMON / toolssize / NVAR,M
      save / toolssize /
c
      if(.not.checklhs(fname,1,8)) return
      if(.not.checkrhs(fname,1,2)) return
      if(.not.getrhsvar(1,'c', Mp, Np, lP)) return
c
      efirst = .false.
      lfirst = .false.
      nvfrst = .false.
      if(rhs.eq.2) then
         if(.not.getrhsvar(2,'b', Mo, No, lO)) return
         efirst = istk(lO).ne. 0
         lfirst = istk(lO+1).ne. 0
         nvfrst = istk(lO+2).ne. 0
      endif
c
      mode(1)=1
      mode(2)=0
      path=cstk(lP:lP+mp*np)
      prbdat=0
      call clunit(prbdat,path,mode)
      if(err.gt.0) then
         call error(err)
         return
      endif

c     read the problem dimension to be able to allocate
      READ(prbdat,'(2i8)') NVAR,NG
      rewind(prbdat)

      MMAX=NG
      if(.not.createvar(3,'d', MMAX, 3, l1)) goto 10 
      if(.not.createvar(4,'i', MMAX, 2, l2)) goto 10 
      
      if(.not.createvar(5,'d', NVAR, 1, lX)) goto 10
      if(.not.createvar(6,'d', NVAR, 1, lBL)) goto 10 
      if(.not.createvar(7,'d', NVAR, 1, lBU)) goto 10 

      CALL CSETUP(prbdat,wte,NVAR,M,stk(lX),stk(lBL),stk(lBU),NVAR,
     *     istk(l2),istk(l2+MMAX),stk(l1),stk(l1+MMAX),stk(L1+2*MMAX),
     *     MMAX,EFIRST, LFIRST, NVFRST )

      ierr=getcuterr()
      if (ierr.ne.0) then
         if (ierr.eq.-1) then
            buf='Overdimensionned problem'
         elseif(ierr.eq.1) then
            buf='the problem includes general constraints'
         elseif(ierr.eq.2) then
            buf='the problem uses no variables'
         elseif(ierr.eq.3) then
            buf='the problem is vacuous'
         endif
            call error(998)
         return
      endif
      if(.not.createvar(8,'d', M, 1, lV)) goto 10 
      call dcopy(M,stk(l1),1,stk(lV),1)
      if(.not.createvar(9,'d', M, 1, lCL)) goto 10 
      call dcopy(M,stk(l1+MMAX),1,stk(lCL),1)
      if(.not.createvar(10,'d', M, 1, lCU)) goto 10 
      call dcopy(M,stk(l1+2*MMAX),1,stk(lCU),1)
      if(.not.createvar(11,'b', M, 1, lE)) goto 10 
      call icopy(M,istk(l2),1,istk(lE),1)
      if(.not.createvar(12,'b', M, 1, lL)) goto 10 
      call icopy(M,istk(l2+MMAX),1,istk(lL),1)

      lhsvar(1)=5
      lhsvar(2)=6
      lhsvar(3)=7
      lhsvar(4)=8
      lhsvar(5)=9
      lhsvar(6)=10
      lhsvar(7)=11
      lhsvar(8)=12

 10   call clunit(-prbdat,path,mode)
      return
      end

      subroutine intcdimen(fname)
c     Author: S. Steer, Copyright INRIA
c     [n,m]=cdimen
      include 'stack.h'

      logical getrhsvar,createvar
      logical checklhs,checkrhs

      external getrhsvar,createvar, checklhs,checkrhs
      character fname*(*)
      COMMON / toolssize / NVAR,M
      save / toolssize /
c
      rhs=max(0,rhs)
      if(.not.checklhs(fname,1,2)) return
      if(.not.checkrhs(fname,0,0)) return
      if(.not.createvar(1,'d', 1, 1, lN)) return
      stk(lN)=NVAR
      if(.not.createvar(2,'d', 1, 1, lM)) return
      stk(lM)=M
c
      lhsvar(1)=1
      lhsvar(2)=2
      return
      end

      subroutine intcnames(fname)
c     Author: S. Steer, Copyright INRIA
c     [PNAME,XNAMES,GNAMES]=unames()
      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs,cresmat4
      external getrhsvar,createvar, checklhs,checkrhs,cresmat4
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      rhs=max(0,rhs)
      if(.not.checkrhs(fname,0,0)) return
      if(.not.checklhs(fname,1,3)) return

      if(.not.createvar(1,'c', 10, 1, lPNAME)) return
      if(.not.createvar(2,'c', NVAR, 10, lXNAMES)) return
      if(.not.createvar(3,'c', M, 10, lGNAMES)) return

      CALL CNAMES( NVAR,M,cstk(lPNAME:),cstk(lXNAMES:),cstk(lGNAMES:))
      lhsvar(1)=1
      lhsvar(2)=2
      lhsvar(3)=3

      return
      end

      subroutine intcvarty(fname)
c     Author: S. Steer, Copyright INRIA
c     ivarty=cvarty()

      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      rhs=max(0,rhs)
      if(.not.checkrhs(fname,0,0)) return
      if(.not.checklhs(fname,1,1)) return

      if(.not.createvar(1,'i', NVAR, 1, lI)) return
      call CVARTY(NVAR, istk(lI) )
      lhsvar(1)=1
      return
      end

      subroutine intcfn(fname)
c     Author: S. Steer, Copyright INRIA
c     [F,C]=cfn(X)
      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      if(.not.checkrhs(fname,1,1)) return
      if(.not.checklhs(fname,1,2)) return
      if(.not.getrhsvar(1,'d', Mx, Nx, lX)) return
      if (mx*nx.ne.NVAR) then
          buf='X does not match current problem dimension'
         call error(999)
         return
      endif
      if(.not.createvar(2,'d', 1, 1, lF)) return
      if(.not.createvar(3,'d', M, 1, lC)) return
      CALL CFN( NVAR,M, stk(lX), stk(lF),M,stk(lC) )
      lhsvar(1)=2
      lhsvar(2)=3
      return
      end

      subroutine intcgr(fname)
c     Author: S. Steer, Copyright INRIA
c      [G,Cjac]=cgr(X,V,options)
      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
      logical jtrans,grlagf
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      if(.not.checkrhs(fname,1,3)) return
      if(.not.checklhs(fname,1,2)) return
      if(.not.getrhsvar(1,'d', Mx, Nx, lX)) return
      if (mx*nx.ne.NVAR) then
         buf='X does not match current problem dimension'
         call error(999)
         return
      endif
      jtrans = .false.
      grlagf = .false.
      if(rhs.ge.2) then
         if(.not.getrhsvar(1,'d', Mv, Nv, lV)) return
         grlagf=.true.
      endif
      if(rhs.eq.3) then
         if(.not.getrhsvar(1,'b', 1, 2, lO)) return
         JTRANS=istk(lO).ne.0
         GRLAGF=istk(lO+1).ne.0
      endif
      if ( .not. jtrans ) then
         lc1 = m
         lc2 = nvar
      else
         lc1 = nvar
         lc2 = m
      end if
      if(.not.createvar(2,'d', NVAR, 1, lG)) return
      if(.not.createvar(3,'d', lc1, lc2, lCJAC)) return

      CALL CGR(NVAR,M,stk(lX),GRLAGF, 1, stk(lV) ,
     *     stk(lG),JTRANS, LC1, LC2,  stk(lCJAC) )
      lhsvar(1)=2
      lhsvar(2)=3
      return
      end


      subroutine intcofg(fname)
c     Author: S. Steer, Copyright INRIA
c     [F,G]=cofg(X)
      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      if(.not.checkrhs(fname,1,1)) return
      if(.not.checklhs(fname,1,2)) return

      if(.not.getrhsvar(1,'d', Mx, Nx, lX)) return
      if (mx*nx.ne.NVAR) then
         buf='X does not match current problem dimension'
         call error(999)
         return
      endif
      if (lhs.eq.1) then
         if(.not.createvar(2,'d', 1, 1, lF)) return
         CALL COFG( NVAR,stk(lX), stk(lF), stk(lF), .FALSE. )
         lhsvar(1)=2
      else
         if(.not.createvar(2,'d', 1, 1, lF)) return
         if(.not.createvar(3,'d', NVAR , 1, lG)) return
          CALL COFG( NVAR, stk(lX), stk(lF), stk(lG),.TRUE.)
         lhsvar(1)=2
         lhsvar(2)=3
      endif
      return
      end

      subroutine intcdh(fname)
c     Author: S. Steer, Copyright INRIA
c     H=udh(X,V)
      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      if(.not.checkrhs(fname,2,2)) return
      if(.not.checklhs(fname,1,1)) return
      if(.not.getrhsvar(1,'d', Mx, Nx, lX)) return
      if (mx*nx.ne.NVAR) then
         buf='X does not match current problem dimension'
         call error(999)
         return
      endif
      if(.not.getrhsvar(2,'d', Mv, Nv, lV)) return
      if (mv*nv.ne.M) then
         buf='Incorrect dimension'
         call error(999)
         return
      endif

      if(.not.createvar(3,'d', NVAR, NVAR, lDH)) return
      CALL CDH( NVAR, M,stk(lX),M,stk(lV),NVAR, stk(lDH))
      lhsvar(1)=3
      return
      end


      subroutine intcgrdh(fname)
c     Author: S. Steer, Copyright INRIA
c     [G,CJAC,H]=cgrdh(X,V,options)
      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
      logical JTRANS,GRLAGF
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      if(.not.checkrhs(fname,2,3)) return
      if(.not.checklhs(fname,1,3)) return
      if(.not.getrhsvar(1,'d', Mx, Nx, lX)) return
      if (mx*nx.ne.NVAR) then
         buf='X does not match current problem dimension'
         call error(999)
         return
      endif
      if(.not.getrhsvar(2,'d', Mv, Nv, lV)) return
      if (mv*nv.ne.M) then
         buf='Incorrect dimension'
         call error(999)
         return
      endif
      JTRANS = .FALSE.
      GRLAGF = .FALSE.
      if(rhs.eq.3) then
         if(.not.getrhsvar(3,'b', Mo, No, lO)) return
         if (m0*n0.ne.2) then
            buf='Incorrect dimension'
            call error(999)
            return
         endif
         JTRANS = istk(lO).ne.0
         GRLAGF = istk(lO+1).ne.0
      endif
      if ( .not. jtrans ) then
         lc1 = m
         lc2 = nvar
      else
         lc1 = nvar
         lc2 = m
      end if
      if(.not.createvar(rhs+1,'d', NVAR, 1, lG)) return
      if(.not.createvar(rhs+2,'d', lc1, lc2, lCJAC)) return
      if(.not.createvar(rhs+3,'d', NVAR, NVAR, lDH)) return

      CALL CGRDH( NVAR,M,stk(lX),GRLAGF,M,stk(lV),stk(lG),JTRANS, 
     $     LC1,LC2,stk(lCJAC),NVAR,stk(lDH))

      lhsvar(1)=rhs+1
      lhsvar(2)=rhs+2
      lhsvar(3)=rhs+3
      return
      end

      subroutine intcreprt(fname)
c     Author: S. Steer, Copyright INRIA
c     [time,calls]=creprt();    
      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      rhs=max(0,rhs)
      if(.not.checkrhs(fname,0,0)) return
      if(.not.checklhs(fname,1,2)) return
      if(.not.createvar(1,'r', 1, 2, lT)) return
      if(.not.createvar(2,'r', 1, 7, lC)) return
      call UREPRT(sstk(lC), sstk(lT))
      lhsvar(1)=1
      lhsvar(2)=2
      return
      end


      subroutine intccfg(fname)
c     Author: S. Steer, Copyright INRIA
c     [c,cjac]=ccfg(x,jtrans)
      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
      logical GRAD,JTRANS
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      if(.not.checkrhs(fname,1,2)) return
      if(.not.checklhs(fname,1,2)) return
      if(.not.getrhsvar(1,'d', Mx, Nx, lX)) return
      if (mx*nx.ne.NVAR) then
         buf='X does not match current problem dimension'
         call error(999)
         return
      endif
C  Decide if the Jacobian is required.  If yes, decide if its transpose
C  is required.
         grad = .false.
         jtrans = .false.
         if ( lhs .eq. 2 ) grad = .true.
         if ( grad .and. rhs .eq. 2 ) then
            if(.not.getrhsvar(1,'d', Mi, Ni, li)) return
            i=stk(li)
            if ( i .ne. 0 ) jtrans = .true.
         end if
C  Set row and column dimensions of CJAC based on JTRANS.
         if ( .not. jtrans ) then
            lc1 = m
            lc2 = nvar
         else
            lc1 = nvar
            lc2 = m
         end if
c
C  Get the values of the constraint functions, and possibly their gradients.
C

      if(.not.createvar(rhs+1,'d', M, 1, lC)) return
      if(grad) then
         if(.not.createvar(rhs+2,'d', lc1, lc2, lCJAC)) return
      endif
      call ccfg(nvar,m,stk(lx),m,stk(lc),jtrans,lc1,lc2,stk(lcjac),grad)
      lhsvar(1)=rhs+1
       if(grad) lhsvar(2)=rhs+2
      return
      end

      subroutine intccfsg1(fname)
c     Author: S. Steer,Copyright INRIA
c     [c,ij,v]=ccfg1(x)
      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar,checklhs,checkrhs
      logical GRAD,JTRANS
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      if(.not.checkrhs(fname,1,1)) return
      if(.not.checklhs(fname,1,3)) return
      if(.not.getrhsvar(1,'d', Mx, Nx, lX)) return
      if (mx*nx.ne.NVAR) then
         buf='X does not match current problem dimension'
         call error(999)
         return
      endif
C  Decide if the Jacobian is required.  If yes, decide if its transpose
C  is required.
      grad = .false.
      if ( lhs .eq. 3 ) grad = .true.
C     Not finished
      buf='Not yet implemented'
      call error(9999)
      return
      end

      subroutine intccifg(fname)
c     Author: S. Steer, Copyright INRIA
c     [ci,gci]=ccifg(x,i)
      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
      logical GRAD,JTRANS
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      if(.not.checkrhs(fname,2,2)) return
      if(.not.checklhs(fname,1,2)) return
      if(.not.getrhsvar(1,'d', Mx, Nx, lX)) return
      if (mx*nx.ne.NVAR) then
         buf='X does not match current problem dimension'
         call error(999)
         return
      endif
      if(.not.getrhsvar(2,'d', Mi, Ni, lI)) return
      i=stk(lI)
      if( (i .lt. 1) .or. (i .gt. m) ) then
         buf = 'invalid constraint index.'
         call error(9999)
         return
      endif
c
      if(lhs.eq.2) then
          if(.not.createvar(3,'d', 1, 1, lCI)) return
          if(.not.createvar(4,'d', NVAR, 1, lCGI)) return
          call ccifg( nvar, i, stk(lx), stk(lci), stk(lcgi), .true. )
          lhsvar(1)=3
          lhsvar(2)=4

       else
         if(.not.createvar(3,'d', 1, 1, lCI)) return
         lcgi=lci
         call ccifg( nvar, i, stk(lx), stk(lci), stk(lcgi), .false. )
         lhsvar(1)=3
      endif

      return
      end

      subroutine intccifsg(fname)
c     Author: S. Steer, Copyright INRIA
c     [ci,gci]=ccifsg(x,i)
      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
      logical GRAD,JTRANS
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c 
      buf='Not yet implemented'
      call error(9999)
      return
      end

      subroutine intcidh(fname)
c     Author: S. Steer, Copyright INRIA
c     Hi=cidh(x,i)
      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      if(.not.checkrhs(fname,2,2)) return
      if(.not.checklhs(fname,1,1)) return
      if(.not.getrhsvar(1,'d', Mx, Nx, lX)) return
      if (mx*nx.ne.NVAR) then
         buf='X does not match current problem dimension'
         call error(999)
         return
      endif
      if(.not.getrhsvar(2,'d', Mi, Ni, lI)) return
      i=stk(lI)
      if( (i .lt. 1) .or. (i .gt. m) ) then
         buf = 'invalid constraint index.'
         call error(9999)
         return
      endif

      if(.not.createvar(3,'d', NVAR, NVAR, lDH)) return
      CALL CIDH( NVAR,stk(lX),I,NVAR, stk(lDH))

      lhsvar(1)=3
      return
      end

      subroutine intcish(fname)
c     Author: S. Steer, Copyright INRIA
c     Hi=cish(x,i)
      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
c
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      if(.not.checkrhs(fname,2,2)) return
      if(.not.checklhs(fname,1,1)) return
      if(.not.getrhsvar(1,'d', Mx, Nx, lX)) return
      if (mx*nx.ne.NVAR) then
          buf='X does not match current problem dimension'
         call error(999)
         return
      endif
      if(.not.getrhsvar(2,'d', Mi, Ni, lI)) return
      i=stk(lI)
      if( (i .lt. 1) .or. (i .gt. m) ) then
         buf = 'invalid constraint index.'
         call error(9999)
         return
      endif
      
      buf='Not yet implemented'
      call error(9999)
      return
      end
      subroutine intcprod(fname)
c     Author: S. Steer, Copyright INRIA
c     q=cprod(x,v,p [,goth])

      include 'stack.h'
c
      logical getrhsvar,createvar,checklhs,checkrhs
      external getrhsvar,createvar, checklhs,checkrhs
c
      LOGICAL           GOTH
      character fname*(*)
      common / toolssize / NVAR,M
      save / toolssize /
c     
      rhs=max(0,rhs)
      if(.not.checkrhs(fname,3,4)) return
      if(.not.checklhs(fname,1,1)) return

      if(.not.getrhsvar(1,'d', Mx, Nx, lX)) return
      if (mx*nx.ne.NVAR) then
         buf='X does not match current problem dimension'
         call error(999)
         return
      endif
      if(.not.getrhsvar(2,'d', Mv, Nv, lv)) return
      if (mv*nv.ne.M) then
         buf='Incorrect dimension'
         call error(999)
         return
      endif
      if(.not.getrhsvar(3,'d', Mp, Np, lP)) return
      if (mp*np.ne.NVAR) then
         buf='Incorrect dimension for P'
         call error(999)
         return
      endif
      GOTH=.false.
      if (rhs.eq.4) then
         if(.not.getrhsvar(4,'b', Mg, Ng, lG)) return
         if(istk(lG).ne.0) GOTH=.true.
      endif

      if(.not.createvar(rhs+1,'d', NVAR, 1, lQ)) return
      call CPROD( NVAR, M,GOTH, stk(lX), M, stk(lV), stk(lP), stk(lQ) )
      lhsvar(1)=rhs+1
      return
      end

